USE AdventureWorks

SET STATISTICS IO ON

--SELECT PostalCode,COUNT(*) FROM Person.Address
--GROUP BY PostalCode
--ORDER BY 2 


SELECT * FROM Person.Address 
WHERE PostalCode='92173'
--218 logical reads

SELECT * FROM Person.Address 
WHERE PostalCode='98168'
--280 logical reads


CREATE NONCLUSTERED INDEX IX_Person_Address_PostalCode
ON Person.Address(PostalCode)

SELECT * FROM Person.Address 
WHERE PostalCode='92173'
--4 logical reads

SELECT * FROM Person.Address 
WHERE PostalCode='98168'
--280 logical reads
GO

CREATE PROCEDURE Person.GetByPostalCode @vPostalCode VARCHAR(6)
AS
SELECT * FROM Person.Address 
WHERE PostalCode=@vPostalCode
GO

EXECUTE Person.GetByPostalCode '92173'
--logical reads 4

EXECUTE Person.GetByPostalCode '98168'
--logical reads 432

EXECUTE Person.GetByPostalCode '98168' WITH RECOMPILE
--280

EXECUTE sp_recompile 'Person.GetByPostalCode'

EXECUTE Person.GetByPostalCode '98168'
--280

EXECUTE Person.GetByPostalCode '92173'
--logical reads 280
GO

ALTER PROCEDURE Person.GetByPostalCode @vPostalCode VARCHAR(6)
WITH RECOMPILE
AS
SELECT * FROM Person.Address 
WHERE PostalCode=@vPostalCode


EXECUTE Person.GetByPostalCode '92173'
--logical reads 4

EXECUTE Person.GetByPostalCode '98168'
--280

DROP INDEX IX_Person_Address_PostalCode ON Person.Address
DROP PROCEDURE Person.GetByPostalCode
